#ifndef _UTILS
#define _UTILS

#include <chrono>

template <typename function_name>
void run_while(function_name predicate, int times, int milliseconds)
{
    auto start = std::clock();
    int steps = 0;

    while (true)
    {
        predicate();

        if (++steps == times)
        {
            steps = 0;
            if ((std::clock() - start) * 1000 > milliseconds * CLOCKS_PER_SEC)
            {
                break;
            }
        }
    }
}

#endif